#include <YoggieEngine.h>
#include "Camera.h"
namespace YoggieEngine {

	Camera::Camera(glm::vec3 position, glm::vec3 rotation, float zoom)
		: Position(position), Rotation(rotation), Zoom(zoom) {

		Front = glm::vec3(-1.0f, 0.0f, 0.0f);
		Right = glm::vec3(0.0f, 0.0f, 1.0f);
		Up = glm::vec3(0.0f, 1.0f, 0.0f);


		auto rotated_position = glm::rotate(glm::mat4(1.0f), Rotation.x, glm::vec3(1.0f, 0.0f, 0.0f)) *  glm::vec4(Position, 1.0f);
		ViewMatrix = glm::lookAt(
			Position,
			glm::vec3{ rotated_position.x, rotated_position.y , rotated_position.z } + Front,
			Up);

		ProjectionMatrix = glm::perspective(glm::radians(Zoom), (800.0f / 600.0f), 0.001f, 100.0f);
	
	}

	Camera::~Camera() {

	}



	void Camera::Update() {
		ViewMatrix = glm::lookAt(
			Position,
			Position   + Front,
			Up);
	}

}
