#pragma once 
#define GLFW_STATIC

#include <iostream>
#include <GLFW/glfw3.h>

#include "../EventSystem/Event.h"
#include "../EventSystem/EventListener.h"
namespace YoggieEngine {
    class NativeWindow  {
 
    public:
        NativeWindow(const int width, const int height);
        ~NativeWindow();

        bool WindowShouldClose();

        void SetViewPort(int width , int height);
        void Poll();
        void SwapBuffers();

        GLFWwindow* GetGLFWHandle() { return window; }
        const int getWidth()const { return Width; }
        const int getHeight()const { return Height; }


    private:
        GLFWwindow* window;
        bool FullScreen = false;
        bool Resizable = true;
        bool VSync = false;
        int Width, Height;

        void SetContext();
        static bool InitGLFW();

    };


  
}
